#!/usr/bin/python
#######################################################################
# File  : Install.py
# Author: Souheil CHELFOUH
#         mailto:souheil@chelfouh.com
#         http://www.trollskog.com
# Date  : 2006-02-06
#######################################################################

__author__	= 'Souheil CHELFOUH <souheil@chelfouh.com>'
__docformat__	= 'plaintext'

from StringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.CMFFormController.FormAction import FormActionKey
from Products.Archetypes.Extensions.utils import installTypes
from Products.Archetypes.Extensions.utils import install_subskin
from Products.Archetypes.public import listTypes
from Products.CMFDynamicViewFTI.migrate import migrateFTIs

from Products.TPArtist.config import *
from Products.TPArtist.Extensions.SetupTools import *


def install(self):
    """
    Install TPArtist: install and configure the module 'TPArtist'
    """
    out = StringIO()

    print >> out, "Installation - TPArtist module"

    # Install types
    classes = listTypes(PROJECTNAME)
    installTypes(self, out,
                 classes,
                 PROJECTNAME)


    # Install tools
    setupTool(self, "portal_artist", PROJECTNAME)
    setupConfiglet(self, CONFIGLETS)


    # Install skin
    install_subskin(self, out, product_globals)


    # Migrate FTI, to make sure we get the necessary infrastructure for the
    # 'display' menu to work.
    migrated = migrateFTIs(self, product=PROJECTNAME)


    # Enable portal_factory
    factory = getToolByName(self, 'portal_factory')
    types = factory.getFactoryTypes().keys()
    for trollType in FACTORY:
        if trollType not in types:
            types.append(trollType)
            factory.manage_setPortalFactoryTypes(listOfTypeIds = types)


    # Hide types to navigation
    hideMe(self, HIDDEN, out)


    # Add some basic keywords
    portal_artist = getToolByName(self, 'portal_artist')
    if not portal_artist.getValues('medias'):
        portal_artist.setType(MEDIAS, True, 'Album')
    if not portal_artist.getValues('styles'):
        portal_artist.setType(STYLES, True, 'Artist')

    
    return out.getvalue()


def uninstall(self):
    out = StringIO()

    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in CONFIGLETS:
            configTool.unregisterConfiglet(conf['id'])
            out.write('Removed configlet %s\n' % conf['id'])

    return out.getvalue()
